diff --git a/_ide_helper.php b/_ide_helper.php
index b307038..7f7a796 100644
--- a/_ide_helper.php
+++ b/_ide_helper.php
@@ -15644,916 +17097,1009 @@ namespace {
         }
         
         /**
-         * Determine if the model is totally guarded.
+         * Determine if the model is totally guarded.
+         *
+         * @return bool 
+         * @static 
+         */
+        public static function totallyGuarded(){
+            //Method inherited from \Illuminate\Database\Eloquent\Model            
+            return \Webpatser\Countries\Countries::totallyGuarded();
+        }
+        
+    }
+
+
+    class Image extends \Intervention\Image\Facades\Image{
+        
+        /**
+         * Overrides configuration settings
+         *
+         * @param array $config
+         * @static 
+         */
+        public static function configure($config = array()){
+            return \Intervention\Image\ImageManager::configure($config);
+        }
+        
+        /**
+         * Initiates an Image instance from different input types
+         *
+         * @param mixed $data
+         * @return \Intervention\Image\Image 
+         * @static 
+         */
+        public static function make($data){
+            return \Intervention\Image\ImageManager::make($data);
+        }
+        
+        /**
+         * Creates an empty image canvas
+         *
+         * @param integer $width
+         * @param integer $height
+         * @param mixed $background
+         * @return \Intervention\Image\Image 
+         * @static 
+         */
+        public static function canvas($width, $height, $background = null){
+            return \Intervention\Image\ImageManager::canvas($width, $height, $background);
+        }
+        
+        /**
+         * Create new cached image and run callback
+         * (requires additional package intervention/imagecache)
+         *
+         * @param \Closure $callback
+         * @param integer $lifetime
+         * @param boolean $returnObj
+         * @return \Image 
+         * @static 
+         */
+        public static function cache($callback, $lifetime = null, $returnObj = false){
+            return \Intervention\Image\ImageManager::cache($callback, $lifetime, $returnObj);
+        }
+        
+    }
+
+
+    class Settings extends \anlutro\LaravelSettings\Facade{
+        
+        /**
+         * 
+         *
+         * @static 
+         */
+        public static function getDefaultDriver(){
+            return \anlutro\LaravelSettings\SettingsManager::getDefaultDriver();
+        }
+        
+        /**
+         * 
+         *
+         * @static 
+         */
+        public static function createJsonDriver(){
+            return \anlutro\LaravelSettings\SettingsManager::createJsonDriver();
+        }
+        
+        /**
+         * 
+         *
+         * @static 
+         */
+        public static function createDatabaseDriver(){
+            return \anlutro\LaravelSettings\SettingsManager::createDatabaseDriver();
+        }
+        
+        /**
+         * 
          *
-         * @return bool 
          * @static 
          */
-        public static function totallyGuarded(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::totallyGuarded();
+        public static function createMemoryDriver(){
+            return \anlutro\LaravelSettings\SettingsManager::createMemoryDriver();
         }
         
         /**
-         * Get the relationships that are touched on save.
+         * 
          *
-         * @return array 
          * @static 
          */
-        public static function getTouchedRelations(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getTouchedRelations();
+        public static function createArrayDriver(){
+            return \anlutro\LaravelSettings\SettingsManager::createArrayDriver();
         }
         
         /**
-         * Set the relationships that are touched on save.
+         * Get a driver instance.
          *
-         * @param array $touches
-         * @return $this 
+         * @param string $driver
+         * @return mixed 
          * @static 
          */
-        public static function setTouchedRelations($touches){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::setTouchedRelations($touches);
+        public static function driver($driver = null){
+            //Method inherited from \Illuminate\Support\Manager            
+            return \anlutro\LaravelSettings\SettingsManager::driver($driver);
         }
         
         /**
-         * Get the value indicating whether the IDs are incrementing.
+         * Register a custom driver creator Closure.
          *
-         * @return bool 
+         * @param string $driver
+         * @param \Closure $callback
+         * @return $this 
          * @static 
          */
-        public static function getIncrementing(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getIncrementing();
+        public static function extend($driver, $callback){
+            //Method inherited from \Illuminate\Support\Manager            
+            return \anlutro\LaravelSettings\SettingsManager::extend($driver, $callback);
         }
         
         /**
-         * Set whether IDs are incrementing.
+         * Get all of the created "drivers".
          *
-         * @param bool $value
-         * @return $this 
+         * @return array 
          * @static 
          */
-        public static function setIncrementing($value){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::setIncrementing($value);
+        public static function getDrivers(){
+            //Method inherited from \Illuminate\Support\Manager            
+            return \anlutro\LaravelSettings\SettingsManager::getDrivers();
         }
         
+    }
+
+
+    class Authy extends \Portal\Services\Auth\TwoFactor\Facade{
+        
         /**
-         * Convert the model instance to JSON.
+         * Determine if the given user has two-factor authentication enabled.
          *
-         * @param int $options
-         * @return string 
+         * @param \Portal\Services\Auth\TwoFactor\TwoFactorAuthenticatable $user
+         * @return bool 
          * @static 
          */
-        public static function toJson($options = 0){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::toJson($options);
+        public static function isEnabled($user){
+            return \Portal\Services\Auth\TwoFactor\Authy::isEnabled($user);
         }
         
         /**
-         * Convert the object into something JSON serializable.
+         * Register the given user with the provider.
          *
-         * @return array 
+         * @param \Portal\Services\Auth\TwoFactor\TwoFactorAuthenticatable $user
          * @static 
          */
-        public static function jsonSerialize(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::jsonSerialize();
+        public static function register($user){
+            return \Portal\Services\Auth\TwoFactor\Authy::register($user);
         }
         
         /**
-         * Convert the model instance to an array.
+         * Determine if the given token is valid for the given user.
          *
-         * @return array 
+         * @param \Portal\Services\Auth\TwoFactor\TwoFactorAuthenticatable $user
+         * @param string $token
+         * @return bool 
          * @static 
          */
-        public static function toArray(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::toArray();
+        public static function tokenIsValid($user, $token){
+            return \Portal\Services\Auth\TwoFactor\Authy::tokenIsValid($user, $token);
         }
         
         /**
-         * Convert the model's attributes to an array.
+         * Delete the given user from the provider.
          *
-         * @return array 
+         * @param \Portal\Services\Auth\TwoFactor\TwoFactorAuthenticatable $user
+         * @return bool 
          * @static 
          */
-        public static function attributesToArray(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::attributesToArray();
+        public static function delete($user){
+            return \Portal\Services\Auth\TwoFactor\Authy::delete($user);
         }
         
+    }
+
+
+    class JWTAuth extends \Tymon\JWTAuth\Facades\JWTAuth{
+        
         /**
-         * Get the model's relationships in array form.
+         * Authenticate a user via a token.
          *
-         * @return array 
+         * @return \Tymon\JWTAuth\Contracts\JWTSubject|false 
          * @static 
          */
-        public static function relationsToArray(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::relationsToArray();
+        public static function authenticate(){
+            return \Portal\Services\Auth\Api\JWTAuth::authenticate();
         }
         
         /**
-         * Get an attribute from the model.
+         * Attempt to authenticate the user and return the token.
          *
-         * @param string $key
-         * @return mixed 
+         * @param array $credentials
+         * @return false|string 
          * @static 
          */
-        public static function getAttribute($key){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getAttribute($key);
+        public static function attempt($credentials){
+            //Method inherited from \Tymon\JWTAuth\JWTAuth            
+            return \Portal\Services\Auth\Api\JWTAuth::attempt($credentials);
         }
         
         /**
-         * Get a plain attribute (not a relationship).
+         * Alias for authenticate().
          *
-         * @param string $key
-         * @return mixed 
+         * @return \Tymon\JWTAuth\Contracts\JWTSubject|false 
          * @static 
          */
-        public static function getAttributeValue($key){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getAttributeValue($key);
+        public static function toUser(){
+            //Method inherited from \Tymon\JWTAuth\JWTAuth            
+            return \Portal\Services\Auth\Api\JWTAuth::toUser();
         }
         
         /**
-         * Get a relationship.
+         * Get the authenticated user.
          *
-         * @param string $key
-         * @return mixed 
+         * @return \Tymon\JWTAuth\Contracts\JWTSubject 
          * @static 
          */
-        public static function getRelationValue($key){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getRelationValue($key);
+        public static function user(){
+            //Method inherited from \Tymon\JWTAuth\JWTAuth            
+            return \Portal\Services\Auth\Api\JWTAuth::user();
         }
         
         /**
-         * Determine if a get mutator exists for an attribute.
+         * Generate a token for a given subject.
          *
-         * @param string $key
-         * @return bool 
+         * @param \Tymon\JWTAuth\Contracts\JWTSubject $subject
+         * @return string 
          * @static 
          */
-        public static function hasGetMutator($key){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::hasGetMutator($key);
+        public static function fromSubject($subject){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::fromSubject($subject);
         }
         
         /**
-         * Determine whether an attribute should be cast to a native type.
+         * Alias to generate a token for a given user.
          *
-         * @param string $key
-         * @param array|string|null $types
-         * @return bool 
+         * @param \Tymon\JWTAuth\Contracts\JWTSubject $user
+         * @return string 
          * @static 
          */
-        public static function hasCast($key, $types = null){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::hasCast($key, $types);
+        public static function fromUser($user){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::fromUser($user);
         }
         
         /**
-         * Get the casts array.
+         * Refresh an expired token.
          *
-         * @return array 
+         * @param bool $forceForever
+         * @param bool $resetClaims
+         * @return string 
          * @static 
          */
-        public static function getCasts(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getCasts();
+        public static function refresh($forceForever = false, $resetClaims = false){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::refresh($forceForever, $resetClaims);
         }
         
         /**
-         * Set a given attribute on the model.
+         * Invalidate a token (add it to the blacklist).
          *
-         * @param string $key
-         * @param mixed $value
+         * @param bool $forceForever
          * @return $this 
          * @static 
          */
-        public static function setAttribute($key, $value){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::setAttribute($key, $value);
+        public static function invalidate($forceForever = false){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::invalidate($forceForever);
         }
         
         /**
-         * Determine if a set mutator exists for an attribute.
+         * Alias to get the payload, and as a result checks that
+         * the token is valid i.e. not expired or blacklisted.
          *
-         * @param string $key
-         * @return bool 
+         * @throws \Tymon\JWTAuth\Exceptions\JWTException
+         * @return \Tymon\JWTAuth\Payload 
          * @static 
          */
-        public static function hasSetMutator($key){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::hasSetMutator($key);
+        public static function checkOrFail(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::checkOrFail();
         }
         
         /**
-         * Get the attributes that should be converted to dates.
+         * Check that the token is valid.
          *
-         * @return array 
+         * @return bool 
          * @static 
          */
-        public static function getDates(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getDates();
+        public static function check(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::check();
         }
         
         /**
-         * Convert a DateTime to a storable string.
+         * Get the token.
          *
-         * @param \DateTime|int $value
-         * @return string 
+         * @return \Tymon\JWTAuth\Token|false 
          * @static 
          */
-        public static function fromDateTime($value){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::fromDateTime($value);
+        public static function getToken(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::getToken();
         }
         
         /**
-         * Set the date format used by the model.
+         * Parse the token from the request.
          *
-         * @param string $format
+         * @throws \Tymon\JWTAuth\Exceptions\JWTException
          * @return $this 
          * @static 
          */
-        public static function setDateFormat($format){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::setDateFormat($format);
+        public static function parseToken(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::parseToken();
         }
         
         /**
-         * Decode the given JSON back into an array or object.
+         * Get the raw Payload instance.
          *
-         * @param string $value
-         * @param bool $asObject
-         * @return mixed 
+         * @return \Tymon\JWTAuth\Payload 
          * @static 
          */
-        public static function fromJson($value, $asObject = false){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::fromJson($value, $asObject);
+        public static function getPayload(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::getPayload();
         }
         
         /**
-         * Clone the model into a new, non-existing instance.
+         * Alias for getPayload().
          *
-         * @param array|null $except
-         * @return \Illuminate\Database\Eloquent\Model 
+         * @return \Tymon\JWTAuth\Payload 
          * @static 
          */
-        public static function replicate($except = null){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::replicate($except);
+        public static function payload(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::payload();
         }
         
         /**
-         * Determine if two models have the same ID and belong to the same table.
+         * Convenience method to get a claim value.
          *
-         * @param \Illuminate\Database\Eloquent\Model $model
-         * @return bool 
+         * @param string $claim
+         * @return mixed 
          * @static 
          */
-        public static function is($model){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::is($model);
+        public static function getClaim($claim){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::getClaim($claim);
         }
         
         /**
-         * Get all of the current attributes on the model.
+         * Create a Payload instance.
          *
-         * @return array 
+         * @param \Tymon\JWTAuth\Contracts\JWTSubject $subject
+         * @return \Tymon\JWTAuth\Payload 
          * @static 
          */
-        public static function getAttributes(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getAttributes();
+        public static function makePayload($subject){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::makePayload($subject);
         }
         
         /**
-         * Set the array of model attributes. No checking is done.
+         * Set the token.
          *
-         * @param array $attributes
-         * @param bool $sync
+         * @param \Tymon\JWTAuth\Token|string $token
          * @return $this 
          * @static 
          */
-        public static function setRawAttributes($attributes, $sync = false){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::setRawAttributes($attributes, $sync);
+        public static function setToken($token){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::setToken($token);
         }
         
         /**
-         * Get the model's original attribute values.
+         * Unset the current token.
          *
-         * @param string|null $key
-         * @param mixed $default
-         * @return mixed|array 
+         * @return $this 
          * @static 
          */
-        public static function getOriginal($key = null, $default = null){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getOriginal($key, $default);
+        public static function unsetToken(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::unsetToken();
         }
         
         /**
-         * Sync the original attributes with the current.
+         * Set the request instance.
          *
+         * @param \Illuminate\Http\Request $request
          * @return $this 
          * @static 
          */
-        public static function syncOriginal(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::syncOriginal();
+        public static function setRequest($request){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::setRequest($request);
         }
         
         /**
-         * Sync a single original attribute with its current value.
+         * Get the Manager instance.
          *
-         * @param string $attribute
-         * @return $this 
+         * @return \Tymon\JWTAuth\Manager 
          * @static 
          */
-        public static function syncOriginalAttribute($attribute){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::syncOriginalAttribute($attribute);
+        public static function manager(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::manager();
         }
         
         /**
-         * Determine if the model or given attribute(s) have been modified.
+         * Get the Parser instance.
          *
-         * @param array|string|null $attributes
-         * @return bool 
+         * @return \Tymon\JWTAuth\Http\Parser\Parser 
          * @static 
          */
-        public static function isDirty($attributes = null){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::isDirty($attributes);
+        public static function parser(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::parser();
         }
         
         /**
-         * Determine if the model or given attribute(s) have remained the same.
+         * Get the Payload Factory.
          *
-         * @param array|string|null $attributes
-         * @return bool 
+         * @return \Tymon\JWTAuth\Factory 
          * @static 
          */
-        public static function isClean($attributes = null){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::isClean($attributes);
+        public static function factory(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::factory();
         }
         
         /**
-         * Get the attributes that have been changed since last sync.
+         * Get the Blacklist.
          *
-         * @return array 
+         * @return \Tymon\JWTAuth\Blacklist 
          * @static 
          */
-        public static function getDirty(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getDirty();
+        public static function blacklist(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::blacklist();
         }
         
         /**
-         * Get all the loaded relations for the instance.
+         * Set the custom claims.
          *
-         * @return array 
-         * @static 
-         */
-        public static function getRelations(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getRelations();
+         * @param array $customClaims
+         * @return $this 
+         * @static 
+         */
+        public static function customClaims($customClaims){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::customClaims($customClaims);
         }
         
         /**
-         * Get a specified relationship.
+         * Alias to set the custom claims.
          *
-         * @param string $relation
-         * @return mixed 
+         * @param array $customClaims
+         * @return $this 
          * @static 
          */
-        public static function getRelation($relation){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getRelation($relation);
+        public static function claims($customClaims){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::claims($customClaims);
         }
         
         /**
-         * Determine if the given relation is loaded.
+         * Get the custom claims.
          *
-         * @param string $key
-         * @return bool 
+         * @return array 
          * @static 
          */
-        public static function relationLoaded($key){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::relationLoaded($key);
+        public static function getCustomClaims(){
+            //Method inherited from \Tymon\JWTAuth\JWT            
+            return \Portal\Services\Auth\Api\JWTAuth::getCustomClaims();
         }
         
+    }
+
+
+    class Agent extends \Jenssegers\Agent\Facades\Agent{
+        
         /**
-         * Set the specific relationship in the model.
+         * Get all detection rules. These rules include the additional
+         * platforms and browsers.
          *
-         * @param string $relation
-         * @param mixed $value
-         * @return $this 
+         * @return array 
          * @static 
          */
-        public static function setRelation($relation, $value){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::setRelation($relation, $value);
+        public static function getDetectionRulesExtended(){
+            return \Jenssegers\Agent\Agent::getDetectionRulesExtended();
         }
         
         /**
-         * Set the entire relations array on the model.
+         * 
          *
-         * @param array $relations
-         * @return $this 
+         * @inheritdoc 
          * @static 
          */
-        public static function setRelations($relations){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::setRelations($relations);
+        public static function getRules(){
+            return \Jenssegers\Agent\Agent::getRules();
         }
         
         /**
-         * Get the database connection for the model.
+         * 
          *
-         * @return \Illuminate\Database\Connection 
+         * @return \Jenssegers\Agent\CrawlerDetect 
          * @static 
          */
-        public static function getConnection(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getConnection();
+        public static function getCrawlerDetect(){
+            return \Jenssegers\Agent\Agent::getCrawlerDetect();
         }
         
         /**
-         * Get the current connection name for the model.
+         * Get accept languages.
          *
-         * @return string 
+         * @param string $acceptLanguage
+         * @return array 
          * @static 
          */
-        public static function getConnectionName(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getConnectionName();
+        public static function languages($acceptLanguage = null){
+            return \Jenssegers\Agent\Agent::languages($acceptLanguage);
         }
         
         /**
-         * Set the connection associated with the model.
+         * Get the browser name.
          *
-         * @param string $name
-         * @return $this 
+         * @param null $userAgent
+         * @return string 
          * @static 
          */
-        public static function setConnection($name){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::setConnection($name);
+        public static function browser($userAgent = null){
+            return \Jenssegers\Agent\Agent::browser($userAgent);
         }
         
         /**
-         * Resolve a connection instance.
+         * Get the platform name.
          *
-         * @param string|null $connection
-         * @return \Illuminate\Database\Connection 
+         * @param string $userAgent
+         * @return string 
          * @static 
          */
-        public static function resolveConnection($connection = null){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::resolveConnection($connection);
+        public static function platform($userAgent = null){
+            return \Jenssegers\Agent\Agent::platform($userAgent);
         }
         
         /**
-         * Get the connection resolver instance.
+         * Get the device name.
          *
-         * @return \Illuminate\Database\ConnectionResolverInterface 
+         * @param string $userAgent
+         * @return string 
          * @static 
          */
-        public static function getConnectionResolver(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getConnectionResolver();
+        public static function device($userAgent = null){
+            return \Jenssegers\Agent\Agent::device($userAgent);
         }
         
         /**
-         * Set the connection resolver instance.
+         * Check if the device is a desktop computer.
          *
-         * @param \Illuminate\Database\ConnectionResolverInterface $resolver
-         * @return void 
+         * @param string $userAgent deprecated
+         * @param array $httpHeaders deprecated
+         * @return bool 
          * @static 
          */
-        public static function setConnectionResolver($resolver){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            \Webpatser\Countries\Countries::setConnectionResolver($resolver);
+        public static function isDesktop($userAgent = null, $httpHeaders = null){
+            return \Jenssegers\Agent\Agent::isDesktop($userAgent, $httpHeaders);
         }
         
         /**
-         * Unset the connection resolver for models.
+         * Check if the device is a mobile phone.
          *
-         * @return void 
+         * @param string $userAgent deprecated
+         * @param array $httpHeaders deprecated
+         * @return bool 
          * @static 
          */
-        public static function unsetConnectionResolver(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            \Webpatser\Countries\Countries::unsetConnectionResolver();
+        public static function isPhone($userAgent = null, $httpHeaders = null){
+            return \Jenssegers\Agent\Agent::isPhone($userAgent, $httpHeaders);
         }
         
         /**
-         * Get the event dispatcher instance.
+         * Get the robot name.
          *
-         * @return \Illuminate\Contracts\Events\Dispatcher 
+         * @param string $userAgent
+         * @return string|bool 
          * @static 
          */
-        public static function getEventDispatcher(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getEventDispatcher();
+        public static function robot($userAgent = null){
+            return \Jenssegers\Agent\Agent::robot($userAgent);
         }
         
         /**
-         * Set the event dispatcher instance.
+         * Check if device is a robot.
          *
-         * @param \Illuminate\Contracts\Events\Dispatcher $dispatcher
-         * @return void 
+         * @param string $userAgent
+         * @return bool 
          * @static 
          */
-        public static function setEventDispatcher($dispatcher){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            \Webpatser\Countries\Countries::setEventDispatcher($dispatcher);
+        public static function isRobot($userAgent = null){
+            return \Jenssegers\Agent\Agent::isRobot($userAgent);
         }
         
         /**
-         * Unset the event dispatcher for models.
+         * 
          *
-         * @return void 
+         * @inheritdoc 
          * @static 
          */
-        public static function unsetEventDispatcher(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            \Webpatser\Countries\Countries::unsetEventDispatcher();
+        public static function version($propertyName, $type = 'text'){
+            return \Jenssegers\Agent\Agent::version($propertyName, $type);
         }
         
         /**
-         * Get the mutated attributes for a given instance.
+         * Get the current script version.
+         * 
+         * This is useful for the demo.php file,
+         * so people can check on what version they are testing
+         * for mobile devices.
          *
-         * @return array 
+         * @return string The version number in semantic version format.
          * @static 
          */
-        public static function getMutatedAttributes(){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::getMutatedAttributes();
+        public static function getScriptVersion(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getScriptVersion();
         }
         
         /**
-         * Extract and cache all the mutated attributes of a class.
+         * Set the HTTP Headers. Must be PHP-flavored. This method will reset existing headers.
          *
-         * @param string $class
-         * @return void 
+         * @param array $httpHeaders The headers to set. If null, then using PHP's _SERVER to extract
+         *                           the headers. The default null is left for backwards compatibility.
          * @static 
          */
-        public static function cacheMutatedAttributes($class){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            \Webpatser\Countries\Countries::cacheMutatedAttributes($class);
+        public static function setHttpHeaders($httpHeaders = null){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::setHttpHeaders($httpHeaders);
         }
         
         /**
-         * Determine if the given attribute exists.
+         * Retrieves the HTTP headers.
          *
-         * @param mixed $offset
-         * @return bool 
+         * @return array 
          * @static 
          */
-        public static function offsetExists($offset){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::offsetExists($offset);
+        public static function getHttpHeaders(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getHttpHeaders();
         }
         
         /**
-         * Get the value for a given offset.
+         * Retrieves a particular header. If it doesn't exist, no exception/error is caused.
+         * 
+         * Simply null is returned.
          *
-         * @param mixed $offset
-         * @return mixed 
+         * @param string $header The name of the header to retrieve. Can be HTTP compliant such as
+         *                       "User-Agent" or "X-Device-User-Agent" or can be php-esque with the
+         *                       all-caps, HTTP_ prefixed, underscore seperated awesomeness.
+         * @return string|null The value of the header.
          * @static 
          */
-        public static function offsetGet($offset){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            return \Webpatser\Countries\Countries::offsetGet($offset);
+        public static function getHttpHeader($header){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getHttpHeader($header);
         }
         
         /**
-         * Set the value for a given offset.
+         * 
          *
-         * @param mixed $offset
-         * @param mixed $value
-         * @return void 
          * @static 
          */
-        public static function offsetSet($offset, $value){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            \Webpatser\Countries\Countries::offsetSet($offset, $value);
+        public static function getMobileHeaders(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getMobileHeaders();
         }
         
         /**
-         * Unset the value for a given offset.
+         * Get all possible HTTP headers that
+         * can contain the User-Agent string.
          *
-         * @param mixed $offset
-         * @return void 
+         * @return array List of HTTP headers.
          * @static 
          */
-        public static function offsetUnset($offset){
-            //Method inherited from \Illuminate\Database\Eloquent\Model            
-            \Webpatser\Countries\Countries::offsetUnset($offset);
+        public static function getUaHttpHeaders(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getUaHttpHeaders();
         }
         
-    }
-
-
-    class Image extends \Intervention\Image\Facades\Image{
-        
         /**
-         * Overrides configuration settings
+         * Set CloudFront headers
+         * http://docs.aws.amazon.com/AmazonCloudFront/latest/DeveloperGuide/header-caching.html#header-caching-web-device
          *
-         * @param array $config
+         * @param array $cfHeaders List of HTTP headers
+         * @return boolean If there were CloudFront headers to be set
          * @static 
          */
-        public static function configure($config = array()){
-            return \Intervention\Image\ImageManager::configure($config);
+        public static function setCfHeaders($cfHeaders = null){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::setCfHeaders($cfHeaders);
         }
         
         /**
-         * Initiates an Image instance from different input types
+         * Retrieves the cloudfront headers.
          *
-         * @param mixed $data
-         * @return \Intervention\Image\Image 
+         * @return array 
          * @static 
          */
-        public static function make($data){
-            return \Intervention\Image\ImageManager::make($data);
+        public static function getCfHeaders(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getCfHeaders();
         }
         
         /**
-         * Creates an empty image canvas
+         * Set the User-Agent to be used.
          *
-         * @param integer $width
-         * @param integer $height
-         * @param mixed $background
-         * @return \Intervention\Image\Image 
+         * @param string $userAgent The user agent string to set.
+         * @return string|null 
          * @static 
          */
-        public static function canvas($width, $height, $background = null){
-            return \Intervention\Image\ImageManager::canvas($width, $height, $background);
+        public static function setUserAgent($userAgent = null){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::setUserAgent($userAgent);
         }
         
         /**
-         * Create new cached image and run callback
-         * (requires additional package intervention/imagecache)
+         * Retrieve the User-Agent.
          *
-         * @param \Closure $callback
-         * @param integer $lifetime
-         * @param boolean $returnObj
-         * @return \Image 
+         * @return string|null The user agent if it's set.
          * @static 
          */
-        public static function cache($callback, $lifetime = null, $returnObj = false){
-            return \Intervention\Image\ImageManager::cache($callback, $lifetime, $returnObj);
+        public static function getUserAgent(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getUserAgent();
         }
         
-    }
-
-
-    class Entrust extends \Zizaco\Entrust\EntrustFacade{
-        
         /**
-         * Checks if the current user has a role by its name
+         * Set the detection type. Must be one of self::DETECTION_TYPE_MOBILE or
+         * self::DETECTION_TYPE_EXTENDED. Otherwise, nothing is set.
          *
-         * @param string $name Role name.
-         * @return bool 
+         * @deprecated since version 2.6.9
+         * @param string $type The type. Must be a self::DETECTION_TYPE_* constant. The default
+         *                     parameter is null which will default to self::DETECTION_TYPE_MOBILE.
          * @static 
          */
-        public static function hasRole($role, $requireAll = false){
-            return \Zizaco\Entrust\Entrust::hasRole($role, $requireAll);
+        public static function setDetectionType($type = null){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::setDetectionType($type);
         }
         
         /**
-         * Check if the current user has a permission by its name
+         * 
          *
-         * @param string $permission Permission string.
-         * @return bool 
          * @static 
          */
-        public static function can($permission, $requireAll = false){
-            return \Zizaco\Entrust\Entrust::can($permission, $requireAll);
+        public static function getMatchingRegex(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getMatchingRegex();
         }
         
         /**
-         * Check if the current user has a role or permission by its name
+         * 
          *
-         * @param array|string $roles The role(s) needed.
-         * @param array|string $permissions The permission(s) needed.
-         * @param array $options The Options.
-         * @return bool 
          * @static 
          */
-        public static function ability($roles, $permissions, $options = array()){
-            return \Zizaco\Entrust\Entrust::ability($roles, $permissions, $options);
+        public static function getMatchesArray(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getMatchesArray();
         }
         
         /**
-         * Get the currently authenticated user or null.
+         * Retrieve the list of known phone devices.
          *
-         * @return \Zizaco\Entrust\Illuminate\Auth\UserInterface|null 
+         * @return array List of phone devices.
          * @static 
          */
-        public static function user(){
-            return \Zizaco\Entrust\Entrust::user();
+        public static function getPhoneDevices(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getPhoneDevices();
         }
         
         /**
-         * Filters a route for a role or set of roles.
-         * 
-         * If the third parameter is null then abort with status code 403.
-         * Otherwise the $result is returned.
+         * Retrieve the list of known tablet devices.
          *
-         * @param string $route Route pattern. i.e: "admin/*"
-         * @param array|string $roles The role(s) needed
-         * @param mixed $result i.e: Redirect::to('/')
-         * @param bool $requireAll User must have all roles
-         * @return mixed 
+         * @return array List of tablet devices.
          * @static 
          */
-        public static function routeNeedsRole($route, $roles, $result = null, $requireAll = true){
-            return \Zizaco\Entrust\Entrust::routeNeedsRole($route, $roles, $result, $requireAll);
+        public static function getTabletDevices(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getTabletDevices();
         }
         
         /**
-         * Filters a route for a permission or set of permissions.
-         * 
-         * If the third parameter is null then abort with status code 403.
-         * Otherwise the $result is returned.
+         * Alias for getBrowsers() method.
          *
-         * @param string $route Route pattern. i.e: "admin/*"
-         * @param array|string $permissions The permission(s) needed
-         * @param mixed $result i.e: Redirect::to('/')
-         * @param bool $requireAll User must have all permissions
-         * @return mixed 
+         * @return array List of user agents.
          * @static 
          */
-        public static function routeNeedsPermission($route, $permissions, $result = null, $requireAll = true){
-            return \Zizaco\Entrust\Entrust::routeNeedsPermission($route, $permissions, $result, $requireAll);
+        public static function getUserAgents(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getUserAgents();
         }
         
         /**
-         * Filters a route for role(s) and/or permission(s).
-         * 
-         * If the third parameter is null then abort with status code 403.
-         * Otherwise the $result is returned.
+         * Retrieve the list of known browsers. Specifically, the user agents.
          *
-         * @param string $route Route pattern. i.e: "admin/*"
-         * @param array|string $roles The role(s) needed
-         * @param array|string $permissions The permission(s) needed
-         * @param mixed $result i.e: Redirect::to('/')
-         * @param bool $requireAll User must have all roles and permissions
-         * @return void 
+         * @return array List of browsers / user agents.
          * @static 
          */
-        public static function routeNeedsRoleOrPermission($route, $roles, $permissions, $result = null, $requireAll = false){
-            \Zizaco\Entrust\Entrust::routeNeedsRoleOrPermission($route, $roles, $permissions, $result, $requireAll);
+        public static function getBrowsers(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getBrowsers();
         }
         
-    }
-
-
-    class Settings extends \anlutro\LaravelSettings\Facade{
-        
         /**
-         * 
+         * Retrieve the list of known utilities.
          *
+         * @return array List of utilities.
          * @static 
          */
-        public static function getDefaultDriver(){
-            return \anlutro\LaravelSettings\SettingsManager::getDefaultDriver();
+        public static function getUtilities(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getUtilities();
         }
         
         /**
-         * 
+         * Method gets the mobile detection rules. This method is used for the magic methods $detect->is*().
          *
+         * @deprecated since version 2.6.9
+         * @return array All the rules (but not extended).
          * @static 
          */
-        public static function createJsonDriver(){
-            return \anlutro\LaravelSettings\SettingsManager::createJsonDriver();
+        public static function getMobileDetectionRules(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getMobileDetectionRules();
         }
         
         /**
+         * Method gets the mobile detection rules + utilities.
          * 
+         * The reason this is separate is because utilities rules
+         * don't necessary imply mobile. This method is used inside
+         * the new $detect->is('stuff') method.
          *
+         * @deprecated since version 2.6.9
+         * @return array All the rules + extended.
          * @static 
          */
-        public static function createDatabaseDriver(){
-            return \anlutro\LaravelSettings\SettingsManager::createDatabaseDriver();
+        public static function getMobileDetectionRulesExtended(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getMobileDetectionRulesExtended();
         }
         
         /**
-         * 
+         * Retrieve the list of mobile operating systems.
          *
+         * @return array The list of mobile operating systems.
          * @static 
          */
-        public static function createMemoryDriver(){
-            return \anlutro\LaravelSettings\SettingsManager::createMemoryDriver();
+        public static function getOperatingSystems(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getOperatingSystems();
         }
         
         /**
+         * Check the HTTP headers for signs of mobile.
          * 
+         * This is the fastest mobile check possible; it's used
+         * inside isMobile() method.
          *
+         * @return bool 
          * @static 
          */
-        public static function createArrayDriver(){
-            return \anlutro\LaravelSettings\SettingsManager::createArrayDriver();
+        public static function checkHttpHeadersForMobile(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::checkHttpHeadersForMobile();
         }
         
         /**
-         * Get a driver instance.
+         * Check if the device is mobile.
+         * 
+         * Returns true if any type of mobile device detected, including special ones
          *
-         * @param string $driver
-         * @return mixed 
+         * @param null $userAgent deprecated
+         * @param null $httpHeaders deprecated
+         * @return bool 
          * @static 
          */
-        public static function driver($driver = null){
-            //Method inherited from \Illuminate\Support\Manager            
-            return \anlutro\LaravelSettings\SettingsManager::driver($driver);
+        public static function isMobile($userAgent = null, $httpHeaders = null){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::isMobile($userAgent, $httpHeaders);
         }
         
         /**
-         * Register a custom driver creator Closure.
+         * Check if the device is a tablet.
+         * 
+         * Return true if any type of tablet device is detected.
          *
-         * @param string $driver
-         * @param \Closure $callback
-         * @return $this 
+         * @param string $userAgent deprecated
+         * @param array $httpHeaders deprecated
+         * @return bool 
          * @static 
          */
-        public static function extend($driver, $callback){
-            //Method inherited from \Illuminate\Support\Manager            
-            return \anlutro\LaravelSettings\SettingsManager::extend($driver, $callback);
+        public static function isTablet($userAgent = null, $httpHeaders = null){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::isTablet($userAgent, $httpHeaders);
         }
         
         /**
-         * Get all of the created "drivers".
+         * This method checks for a certain property in the
+         * userAgent.
          *
-         * @return array 
+         * @todo : The httpHeaders part is not yet used.
+         * @param string $key
+         * @param string $userAgent deprecated
+         * @param string $httpHeaders deprecated
+         * @return bool|int|null 
          * @static 
          */
-        public static function getDrivers(){
-            //Method inherited from \Illuminate\Support\Manager            
-            return \anlutro\LaravelSettings\SettingsManager::getDrivers();
+        public static function is($key, $userAgent = null, $httpHeaders = null){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::is($key, $userAgent, $httpHeaders);
         }
         
-    }
-
-
-    class Authy extends \Portal\Services\Auth\TwoFactor\Facade{
-        
         /**
-         * Determine if the given user has two-factor authentication enabled.
+         * Some detection rules are relative (not standard),
+         * because of the diversity of devices, vendors and
+         * their conventions in representing the User-Agent or
+         * the HTTP headers.
+         * 
+         * This method will be used to check custom regexes against
+         * the User-Agent string.
          *
-         * @param \Portal\Services\Auth\TwoFactor\TwoFactorAuthenticatable $user
+         * @param $regex
+         * @param string $userAgent
          * @return bool 
+         * @todo : search in the HTTP headers too.
          * @static 
          */
-        public static function isEnabled($user){
-            return \Portal\Services\Auth\TwoFactor\Authy::isEnabled($user);
+        public static function match($regex, $userAgent = null){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::match($regex, $userAgent);
         }
         
         /**
-         * Register the given user with the provider.
+         * Get the properties array.
          *
-         * @param \Portal\Services\Auth\TwoFactor\TwoFactorAuthenticatable $user
+         * @return array 
          * @static 
          */
-        public static function register($user){
-            return \Portal\Services\Auth\TwoFactor\Authy::register($user);
+        public static function getProperties(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::getProperties();
         }
         
         /**
-         * Determine if the given token is valid for the given user.
+         * Prepare the version number.
          *
-         * @param \Portal\Services\Auth\TwoFactor\TwoFactorAuthenticatable $user
-         * @param string $token
-         * @return bool 
+         * @todo Remove the error supression from str_replace() call.
+         * @param string $ver The string version, like "2.6.21.2152";
+         * @return float 
          * @static 
          */
-        public static function tokenIsValid($user, $token){
-            return \Portal\Services\Auth\TwoFactor\Authy::tokenIsValid($user, $token);
+        public static function prepareVersionNo($ver){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::prepareVersionNo($ver);
         }
         
         /**
-         * Delete the given user from the provider.
+         * Retrieve the mobile grading, using self::MOBILE_GRADE_* constants.
          *
-         * @param \Portal\Services\Auth\TwoFactor\TwoFactorAuthenticatable $user
-         * @return bool 
+         * @return string One of the self::MOBILE_GRADE_* constants.
          * @static 
          */
-        public static function delete($user){
-            return \Portal\Services\Auth\TwoFactor\Authy::delete($user);
+        public static function mobileGrade(){
+            //Method inherited from \Mobile_Detect            
+            return \Jenssegers\Agent\Agent::mobileGrade();
         }
         
     }
